/*
 * @file list.h
 *
 * This file has declarations only. It documents the interface
 * provided by the list module. It is the contract between the list
 * module and other modules using the list module.
 */

#ifndef LIST_H
#define LIST_H

struct list {
    int  info;
    struct list *next;   /* self  reference  */
};

struct list*
push_front(struct list *my_list , int  value);

struct list*
push_back(struct list* my_list , int  value);

void
print_list(struct list* my_list);

void
dispose_list(struct list* my_list);

typedef void (*func)(int num, void *state);

void
foreach_list_simple(struct list* my_list, void (*func)(int num));

void
foreach_list(struct list* my_list,
	     void (*func)(int num, void *state),
	     void *state);

#endif
